/*
 * Copyright (c) 2010, Paul Merlin. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
package org.qipki.ca.http.presentation.rest.resources;

import org.qi4j.api.injection.scope.Service;

import org.qipki.ca.http.presentation.rest.RestletValuesFactory;
import org.qipki.ca.http.presentation.rest.api.RestApiService;

import org.restlet.data.MediaType;
import org.restlet.representation.Representation;
import org.restlet.representation.StringRepresentation;
import org.restlet.resource.ResourceException;

public class CaApiRootResource
        extends AbstractResource
{

    @Service
    private RestletValuesFactory restValuesFactory;

    public CaApiRootResource( @Service RestApiService restApi )
    {
        super( restApi );
    }

    @Override
    protected Representation get()
            throws ResourceException
    {
        return new StringRepresentation( restValuesFactory.caApiURIs().toJSON(), MediaType.APPLICATION_JSON );
    }

}
